Option Explicit
On Error Resume Next

Include "pva-agent-helper.vbs"

' This constant is replaced by the build system. In the result script this bool value will reflect 
' the configfuration of the PVA core. If PVA_MN_CORE is 1, then we work for PVA management node core,
' otherwise the core we deal with is for slave agent.    
const PVA_MN_CORE=0' 1

LogProgress "Executing " & Wscript.ScriptName & " PVA_MN_CORE=" & PVA_MN_CORE

ConfigureCore

If Err.number = 0 Then
	LogProgress Wscript.ScriptName & " finished succesfully"
	WScript.Quit 0
Else
	FailedQuitErr "Failed to execute core preinstall configuration"
End If

Sub ConfigureCore
	LogProgress "Starting agent preinstall configuration"

	StopService GetAgentServiceName(PVA_MN_CORE)

	UninstallPreviousVersion

	LogProgress "Core preinstall configuration finished"
End Sub

Sub UninstallPreviousVersion
	On Error Resume Next
	LogProgress "Trying to uninstall PIM 4.0"
	Dim installer, objArgs
	Set objArgs = WScript.Arguments

	Set installer = CreateObject("WindowsInstaller.Installer")
	Dim related_product
	Dim productName, prodVersion

	For Each related_product In installer.RelatedProducts("{6F8A99AF-96C7-482D-941E-96796F249721}")
		productName = installer.ProductInfo(related_product, "InstalledProductName")
		prodVersion = installer.ProductInfo(related_product, "VersionString")
		If objArgs.Named.Exists("log") Then
			installer.EnableLog "v", objArgs.Named.Item("log") & "\" & productName & "-uninstall.log"
		End If
		LogProgress "Uninstalling " & productName & ". Version:" & prodVersion
		installer.InstallProduct installer.ProductInfo(related_product, "LocalPackage"), "REMOVE=ALL"
		If Err.Number <> 0 Then
			LogError Err.Number, "Failed to uninstall " & productName & ". Version:" & prodVersion
			WScript.Quit(-1)
		End If
	Next

	If Err.number <> 0 Then
		LogProgress "Failed to uninstall PIM"
	End If
End Sub

' Include vzlVBLib.vbs
Sub Include(cNameScript)
	On Error Resume Next
	Dim oFS, oFile
	
	cNameScript = Mid(Wscript.ScriptFullName, 1, InStrRev(Wscript.ScriptFullName, "\")) & cNameScript
	
	Set oFS = CreateObject("Scripting.Filesystemobject")
	
	Set oFile = oFS.OpenTextFile(cNameScript)
	If Err.number <> 0 Then
		WScript.Echo "Failed to open include file '" & cNameScript & "' - " & Err.source & ", " & Err.Description
		WScript.Quit(-1)
	End If
	
	ExecuteGlobal oFile.ReadAll()
	If Err.number <> 0 Then
		WScript.Echo "Failed to ExecuteGlobal include file '" & cNameScript & "' - " & Err.source & ", " & Err.Description
		WScript.Quit(-1)
	End If

	oFile.Close
End Sub
