Option Explicit
On Error Resume Next

Include "pva-agent-helper.vbs"

' This constant is replaced by the build system. In the result script this bool value will reflect 
' the configfuration of the PVA core. If PVA_MN_CORE is 1, then we work for PVA management node core,
' otherwise the core we deal with is for salve agent.    
const PVA_MN_CORE=0' 1

LogProgress "Executing " & Wscript.ScriptName & " PVA_MN_CORE=" & PVA_MN_CORE

' Call configuration script
ConfigureCore

If Err.number = 0 Then
	LogProgress Wscript.ScriptName & " finished succesfully"
	WScript.Quit 0
Else
	FailedQuitErr "Failed to ConfigureCore"
End If

'
' Functions
'
Sub ConfigureCore()
	LogProgress "Starting core preupgrade configuration"

	CheckPreviousVersion

	LogProgress "Core preupgrade configuration finished succesfully"
End Sub

Sub CheckPreviousVersion
	On Error Resume Next
	LogProgress "Checking for PVA 4.5"
	Dim installer
	Set installer = CreateObject("WindowsInstaller.Installer")
	Dim related_product
	If PVA_MN_CORE=0 Then
		pvaCode="{DFF0CBC0-63E4-4BB0-A2DE-2D0869DC9A73}"
	Else
		pvaCode="{BE28816E-3F89-4333-995A-C1593F8E8FBE}"
	End If

	For Each related_product In installer.RelatedProducts(pvaCode)
		LogError -1, "You can not upgrade from PVA 4.5"
		WScript.Quit(-1)
	Next
End Sub

' Include vzlVBLib.vbs
Sub Include(cNameScript)
	On Error Resume Next
	Dim oFS, oFile
	
	cNameScript = Mid(Wscript.ScriptFullName, 1, InStrRev(Wscript.ScriptFullName, "\")) & cNameScript
	
	Set oFS = CreateObject("Scripting.Filesystemobject")
	
	Set oFile = oFS.OpenTextFile(cNameScript)
	If Err.number <> 0 Then
		WScript.Echo "Failed to open include file '" & cNameScript & "' - " & Err.source & ", " & Err.Description
		WScript.Quit(-1)
	End If
	
	ExecuteGlobal oFile.ReadAll()
	If Err.number <> 0 Then
		WScript.Echo "Failed to ExecuteGlobal include file '" & cNameScript & "' - " & Err.source & ", " & Err.Description
		WScript.Quit(-1)
	End If

	oFile.Close
End Sub
